<?php

namespace EnumType;

/**
 * This class stands for MotifFIV EnumType
 * @subpackage Enumerations
 */
class MotifFIV
{
    /**
     * Constant for value 'CT'
     * @return string 'CT'
     */
    const VALUE_CT = 'CT';
    /**
     * Constant for value 'EXP'
     * @return string 'EXP'
     */
    const VALUE_EXP = 'EXP';
    /**
     * Constant for value 'ENC'
     * @return string 'ENC'
     */
    const VALUE_ENC = 'ENC';
    /**
     * Constant for value 'AUT'
     * @return string 'AUT'
     */
    const VALUE_AUT = 'AUT';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_CT
     * @uses self::VALUE_EXP
     * @uses self::VALUE_ENC
     * @uses self::VALUE_AUT
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_CT,
            self::VALUE_EXP,
            self::VALUE_ENC,
            self::VALUE_AUT,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
